| AI Engine-ML Intrinsics User Guide (v2025.2)

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Data Fields | Static Public Attributes | Friends
bfloat16 Class Reference

`#include <me_native_bfloat16_type.h>`

## Public Types
typedef VBit< 16, false > | BitType

## Public Member Functions
| bfloat16 ()=default
template<int B, bool S>
VBIT_CONSTEXPR | bfloat16 (const VBit< B, S > &a)
template<typename DataType, int E>
| bfloat16 (const VBitVector< DataType, E > &a)
| bfloat16 (float)
VBIT_CONSTEXPR | bfloat16 (VBitInitializeTag tg)
VBIT_CONSTEXPR | bfloat16 (VBitZeroInitializeTag tg)
void | initialize ()
| operator float () const
| operator int () const
bfloat16 | operator*= (bfloat16)
bfloat16 | operator*= (float)
bfloat16 | operator*= (int)
bfloat16 | operator+= (bfloat16)
bfloat16 | operator+= (float)
bfloat16 | operator+= (int)
bfloat16 | operator-= (bfloat16)
bfloat16 | operator-= (float)
bfloat16 | operator-= (int)
bfloat16 | operator/= (bfloat16)
bfloat16 | operator/= (float)
bfloat16 | operator/= (int)
BitType::SBaseType | to_signed () const
BitType::UBaseType | to_unsigned () const
BitType::ValueType & | value ()
const BitType::ValueType & | value () const
void | value (const BitType::ValueType &v)

## Data Fields
BitType | val

## Static Public Attributes
static const int | bits = BitType::bits
static const bool | isSigned = BitType::isSigned

## Friends
std::ostream & | operator<< (std::ostream &os, const bfloat16 &x)
std::istream & | operator>> (std::istream &is, bfloat16 &x)

## Member Typedef Documentation

## ◆ BitType

typedef VBit<16, false> bfloat16::BitType

## Constructor & Destructor Documentation

## ◆ bfloat16() [1/6]

bfloat16::bfloat16 | ( |  | ) |
| default

## ◆ bfloat16() [2/6]

VBIT_CONSTEXPR bfloat16::bfloat16 | ( | VBitInitializeTag | tg | ) |

## ◆ bfloat16() [3/6]

VBIT_CONSTEXPR bfloat16::bfloat16 | ( | VBitZeroInitializeTag | tg | ) |

## ◆ bfloat16() [4/6]

template<int B, bool S>

VBIT_CONSTEXPR bfloat16::bfloat16 | ( | const VBit< B, S > & | a | ) |

## ◆ bfloat16() [5/6]

template<typename DataType, int E>

bfloat16::bfloat16 | ( | const VBitVector< DataType, E > & | a | ) |

## ◆ bfloat16() [6/6]

bfloat16::bfloat16 | ( | float |  | ) |

## Member Function Documentation

## ◆ initialize()

void bfloat16::initialize | ( |  | ) |

## ◆ operator float()

bfloat16::operator float | ( |  | ) | const

## ◆ operator int()

bfloat16::operator int | ( |  | ) | const
| explicit

## ◆ operator*=() [1/3]

bfloat16 bfloat16::operator*= | ( | bfloat16 | a | ) |

## ◆ operator*=() [2/3]

bfloat16 bfloat16::operator*= | ( | float | a | ) |

## ◆ operator*=() [3/3]

bfloat16 bfloat16::operator*= | ( | int | a | ) |

## ◆ operator+=() [1/3]

bfloat16 bfloat16::operator+= | ( | bfloat16 | a | ) |

dont_generate! explicit operator signed char() const; dont_generate! explicit operator short() const; dont_generate! explicit operator unsigned() const; dont_generate! explicit operator unsigned char() const; dont_generate! explicit operator unsigned short() const;

## ◆ operator+=() [2/3]

bfloat16 bfloat16::operator+= | ( | float | a | ) |

## ◆ operator+=() [3/3]

bfloat16 bfloat16::operator+= | ( | int | a | ) |

## ◆ operator-=() [1/3]

bfloat16 bfloat16::operator-= | ( | bfloat16 | a | ) |

## ◆ operator-=() [2/3]

bfloat16 bfloat16::operator-= | ( | float | a | ) |

## ◆ operator-=() [3/3]

bfloat16 bfloat16::operator-= | ( | int | a | ) |

## ◆ operator/=() [1/3]

bfloat16 bfloat16::operator/= | ( | bfloat16 | a | ) |

## ◆ operator/=() [2/3]

bfloat16 bfloat16::operator/= | ( | float | a | ) |

## ◆ operator/=() [3/3]

bfloat16 bfloat16::operator/= | ( | int | a | ) |

## ◆ to_signed()

BitType::SBaseType bfloat16::to_signed | ( |  | ) | const

## ◆ to_unsigned()

BitType::UBaseType bfloat16::to_unsigned | ( |  | ) | const

## ◆ value() [1/3]

BitType::ValueType & bfloat16::value | ( |  | ) |

## ◆ value() [2/3]

const BitType::ValueType & bfloat16::value | ( |  | ) | const

## ◆ value() [3/3]

void bfloat16::value | ( | const BitType::ValueType & | v | ) |

## Friends And Related Symbol Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | os,
|  | const bfloat16 & | x )
| friend

## ◆ operator>>

std::istream & operator>> | ( | std::istream & | is,
|  | bfloat16 & | x )
| friend

## Field Documentation

## ◆ bits

const int bfloat16::bits = BitType::bits
| static

## ◆ isSigned

const bool bfloat16::isSigned = BitType::isSigned
| static

## ◆ val

BitType bfloat16::val

The documentation for this class was generated from the following files:

- me_bfloat16.h
- me_native_bfloat16_type.h
- me_native_bfloat16_opns.h